/***************************************************************************
 *   Copyright (C) 2014 by Yexr   *
 *   yexr@vveye.com   *
 ***************************************************************************/
#ifndef _LIB_T2U_H_
#define _LIB_T2U_H_

#ifdef WIN32
typedef __int64			int64_t;
#else
#include <stdint.h>
#endif

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _T2U_CALLBACK
{
	void (*OnConnect)(		/* P2Pӳɹ*/
				unsigned short local_port,					/* ش˿ں*/
				int usetime								/* P2Pʱ䣨룩*/
	);
	
	void (*OnDisconnect)(		/*P2PʧܻϿ*/
		unsigned short local_port,							/* ش˿ں*/
		int ret											/* Ͽԭ
															-2:	P2Pʧ
															-3:  P2Pж
															-4:  Է
															-5:  豸룬֤ʧ
														*/
	);
}T2uCallBack,*PT2uCallBack;

//ͳ
typedef	struct _T2U_NET_RATE
{								
	int64_t				total_recv;			//ֽܽ
	int64_t				total_send;			//ֽܷ

	float					cur_recv_rate;		//ǰKB/s
	float					cur_send_rate;		//ǰKB/s
	float					cur_rate;			//ǰ KB/s

	float					avg_recv_rate;		//ƽKB/s
	float					avg_send_rate;		//ƽKB/s
	float					avg_rate;			//ƽKB/s

	int					time_sec;			//ͳʱ,
}T2uNetRate,*PT2uNetRate;

//״̬
typedef struct _T2U_NET_STAT
{
	char					ip[20];				//ԷIP
	int					port;				//Է˿
	int					proxy;				//Ƿͨ
	float					lost_rate;			//
	int					bandwidth;			//дKB/s
	int					remote_nattype;		//ԷNAT
	int					local_nattype;		//NAT
	char					ip6[40];				//ԷIPV6ַ
	int					remote_version;		//Է汾
}T2uNetStat,*PT2uNetStat;

/*
ʼ
*/
void		t2u_init(const char* svraddr,unsigned short svrport,const char* svrkey);

/*
ûص
*/
void		t2u_set_callback(PT2uCallBack callback);

/*
P2P˿ڷΧ
min_port:	С˿ں
max_port:	˿ں
*/
void		t2u_set_port_range(unsigned short min_port,unsigned short max_port);

/*
ӳ˿

uuid: Զ豸UUID

remote_port:	Զ豸˿
local_port:	ӳ䵽صĶ˿ڣ0ʾʹ˿

ֵ:	
	>0:  ӳ䵽صĶ˿
	-1:  ӳʧܣ˿ڱռ
*/

int		t2u_add_port(const char* uuid,unsigned short remote_port,unsigned short local_port);

int		t2u_add_port_ex(const char* uuid,const char* remote_ip,unsigned short remote_port,unsigned short local_port);

int		t2u_add_port_v3(const char* uuid,const char* passwd,const char* remote_ip,unsigned short remote_port,unsigned short local_port);

/*
ɾӳ˿
*/
void		t2u_del_port(unsigned short port);

/*
ѯ˿״̬

ֵ:
1:		ͨ
0:		δͨ
-1:		
-2:		P2Pʧܣȴ30Զ
-3:		P2Pжϣȴ30Զ
-4:		Էߣȴ30Զ
-5:		豸룬֤ʧ
*/
int		t2u_port_status(unsigned short port,PT2uNetStat pStat);


/*
ѯͳ

port:	ҪѯĶ˿ںţ0ʾͳȫ
pRate:	ݵʽṹָ

ֵ:
		0:	ɹ
		-1:	˿ڲ
*/
int		t2u_get_rate(unsigned short port,PT2uNetRate pRate);

int		t2u_add_udp_port(const char* uuid,unsigned short remote_port,unsigned short local_port);
int		t2u_add_udp_port_ex(const char* uuid,const char* remote_ip,unsigned short remote_port,unsigned short local_port);
int		t2u_add_udp_port_v3(const char* uuid,const char* passwd,const char* remote_ip,unsigned short remote_port,unsigned short local_port);
void		t2u_del_udp_port(unsigned short port);
int		t2u_udp_port_status(unsigned short port,PT2uNetStat pStat);
int		t2u_get_udp_rate(unsigned short port,PT2uNetRate pRate);


/*
ѯ豸״̬

ֵ:
		1:	豸
		0:	豸
		-1:	ѯʧ
*/
int		t2u_query(const char* uuid);


/*
ѯ豸״̬͸Ӳ

buff:			豸Ļַ
buffsize:		С1024ֽ
ipaddr:		豸IPĻַ
ipsize:		С

ֵ:
		1:	豸
		0:	豸
		-1:	ѯʧ
*/
int		t2u_query_ex(const char * uuid,char* buff,int buffsize,char* ipaddr,int ipsize);


/*
ֱ豸
ıʽÿһ¼ʽΪ: uuid=xxxx,ip=x.x.x.x

buff:			Ļַ
buffsize:		С

ֵ :  
		>=0		ֵ豸
		-1		ʧ
*/
int		t2u_search(char* buff,int buffsize);

/*
ͨزѯԷDVR豸
ѯıʽÿһ¼
ʽΪ: Ҵ|DVRк|ͨ|IP|˿


uuid:		صUUID
outbuff:		ıĻ
buffsize:		С

ֵ:
		1:		ѯɹDVR 豸
		0:		ѯɹ豸
		-1:		ʧ
		-2:		ѯʧ
		-3:		ѯʱԷӦ
*/
int		t2u_search_dvr(const char* uuid,char* outbuff,int buffsize);

/*
ѯ״̬

ֵ:
1:		ӣ״̬
0:		δӷ
-1:		SDKδʼ
-2:		ԿЧ
*/
int		t2u_status();

/*
˳ͷԴ
*/
void		t2u_exit();

#ifdef __cplusplus
}
#endif

#endif


